#!/usr/bin/env python
from assert_exists import *
from isbinary import *
from extension import *
from public import *
from shebang import *

@public
def ispythonsource(path):
    if path is None: return False
    assert_exists(path)
    if extension(path)=="py": return True
    binary = isbinary(path)
    if not binary:
        _shebang = shebang(path)
        if not _shebang: return False
        return "python" in _shebang
    return False

if __name__=="__main__":
    print(ispythonsource(__file__)) # True
    import os,tempfile
    file=tempfile.mkstemp()[1]
    print(ispythonsource(file)) # False
    open(file,"w").write("""#!/usr/bin/env python
import os""")
    print(ispythonsource(file)) # True
    os.unlink(file)
